/*
 * lanzadorPacket.java
 *
 * Created on 23 de diciembre de 2004, 14:22
 */

/**
 *
 * @author  Oscar
 */
public class lanzadorPacket {
    
    private trabajadorPacket trabajador[];
    private int nHilos;
    private int nPaquetes;
    private Packet sigLibre;
    private Object sync, syncLibre, syncInicio, syncFin, syncTermina, syncPreparados;
    private int Faltan;
    private int Procesados;
    private boolean fin_simulacion;
    private boolean inicio_ciclo, fin_ciclo;
    private int Preparados;
        
    /** Creates a new instance of lanzadorPacket */
    public lanzadorPacket(int n) {
        trabajador = new trabajadorPacket[n];
        
                
        nHilos = n;
        nPaquetes = 0;
        sigLibre = null;        
        
        sync = new Object();
        syncLibre = new Object();
        syncInicio = new Object();
        syncFin = new Object();
        syncTermina = new Object();
        syncPreparados = new Object();
        
        fin_simulacion = false;
        inicio_ciclo = false;
        fin_ciclo = false;
        
        for (int i=0; i<n; i++)
        {
            trabajador[i] = new trabajadorPacket();
            
            trabajador[i].start();
            
        }
        
    }
    
    public void Prepara(Packet p)
    {
        Packet aux = p;
        
        Faltan = nHilos;
        Preparados = nHilos;
        
        Procesados = 0;        
               
        //for (int i=0; i<nHilos; i++) trabajador[i].Activo(false);
        
        for (int i=0; i<nHilos; i++)
        {
            // esto se hace al ppio, no cada vez... trabajador[i].setPriority(trabajador[i].NORM_PRIORITY);
            trabajador[i].Asigna(aux); 
            if (aux!=null)
            {
              synchronized(syncLibre){
                 sigLibre = aux;            
                 aux=aux.Next;}
            }
        }
    }
    
    public void InicioCiclo(int n)
    {
        nPaquetes = n;
        //System.out.println("> Iniciamos ciclo -x-x-x");
        // Los hilos esperar???n tras terminar de procesar la lista
        synchronized(syncFin)
        {
            fin_ciclo = false;           
        }
        
        // y avisamos de que ya pueden empezar a procesarla
        synchronized(syncInicio){
            inicio_ciclo = true;
            
            syncInicio.notifyAll();            
        }        
        
        
    }
    
    public void Termina()
    {
        synchronized(syncTermina){            
            fin_simulacion = true;
        }
        
        synchronized(syncInicio)
        {
            inicio_ciclo = true;
            syncInicio.notifyAll();
            
        }
        synchronized(syncFin)
        {
            fin_ciclo = true;
            syncFin.notifyAll();
            
        }
        /*
            
        for (int i=0; i<nHilos; i++)
        {                
            try{
                trabajador[i].interrupt();
            }catch(Exception e){ System.out.println("Excepcion en interrupt"); }
        }
        */
    }
    
    
    public void Espera()
    {
        // Espera a que los hilos terminen de procesar la lista
        
       // System.out.println("> EMPIEZA la ESPERA");        
        synchronized(sync)
        {
            while(Faltan>0)
                try{
                  
                    sync.wait();
                   
                    //System.out.println("Notify recibido");
                }catch(Exception e){
                    System.out.println("???Error en wait!");
                    System.exit(-1);
                }         
        }
                
        // Los hilos no empezar???n hasta que se d??? la se???al        
        synchronized(syncInicio){
            inicio_ciclo = false;
            //syncInicio.notifyAll();
            //System.out.println("## Detenemos INI CICLO");
        }        
        
        // y permitimos la finalizaci???n del proceso de la lista de los hilos
        //System.out.println("AVISAMOS FIN DE CICLO");
        synchronized(syncFin)
        {
            fin_ciclo = true;
            syncFin.notifyAll();                    
        }   
        
        // y esperamos a que los hilos est???n de nuevo listos para trabajar
        
        synchronized(syncPreparados)
        {
            while(Preparados>0)
                try{
                    syncPreparados.wait();                    
                }catch(Exception e){
                    System.out.println("???Error en wait!");
                    System.exit(-1);
                }         
        }        
        //System.out.println(">>>Termina la ESPERA");
    }
    
    private class trabajadorPacket extends Thread
    {
        private Packet miPacket;
        private boolean activo;
        
        public trabajadorPacket() {miPacket = null; activo = false;}
        public trabajadorPacket(Packet p) {miPacket = p;}
        
        public void Asigna(Packet p) { miPacket = p; }
        //public void Activo(boolean b) {activo = b;}
        
      /*  public void ein()
        {
            if (miPacket!=null)
            { if (miPacket.LaRed.procesando_lista) new Error(this, "EIN???"); }
        }
    */
        
        public void run()
        {   
          Packet aux;
           // System.out.println("Empieza el hilo");
            while(!fin_simulacion)
            {                           
                // PUNTO DE SINCRONISMO
                ///////////////////////
                
             //   if (miPacket!=null) System.out.println(this+" espera se???al de salida ("+miPacket.idpaq);
               // else System.out.println(this+" espera se???al de salida (NULL)");
                
                synchronized(syncInicio){
                    while(!inicio_ciclo)
                    {
                        //synchronized(syncInicio){
                        try{                            
                           // System.out.println("+++++++Entro");
                            syncInicio.wait();
                            //System.out.println("-------Salgo");
                        }catch(Exception e) {System.out.println("Excepcion en syncInicio "+e);}
                    }
                }
                
             //   ein();
                
              //  System.out.println(this+" sale");
                //System.out.println(this+" RECIBIDA se???al de salida");
                
              
                
                while(miPacket!=null)
                {
                 //   System.out.println(this+" procesa "+miPacket.idpaq);
                    
                  // no creo que haga falta sincro esto (FER) quitarlo cuando pueda      
                  synchronized(miPacket){
                           miPacket.RunCycle();
                  }

                    synchronized(syncLibre) 
                        {
                          miPacket=sigLibre;
                          if (sigLibre != null) sigLibre = sigLibre.Next;}
                }
                
                synchronized(sync)
                {
                    Faltan--;
                    sync.notify(); 
                }
                
                // PUNTO DE SINCRONISMO
            ///////////////////////
                
           //     ein();
                
                   
                
                synchronized(syncFin){
                    while(!fin_ciclo)
                    {
                            try{
                                syncFin.wait();
                            }catch(Exception e) {System.out.println("Excepcion en syncFin"+e);}

                    }
                    
                }
                
                synchronized(syncPreparados)
                {
                    if (Preparados>0) Preparados--;
                    syncPreparados.notify();                
                }  
           }
        }
    }
    
}
